
#define	AVL_KEY_BUF_LEN		32
#define	AVL_TREE_MAX_DEPTH	24	/* approx 16 million nodes */

#define	AVL_KEY_INT		1
#define AVL_KEY_UINT		2
#define	AVL_KEY_STRING		3


typedef struct avl_node_s
{
	char		key_buf[AVL_KEY_BUF_LEN + 1];
	void 		*key;
	void 		*data;
	struct avl_node_s *left,
			*right;
	int 		height;
} avl_node;


typedef struct avl_tree_s
{
	avl_node	*root;
	int		key_type,
			node_count;
} avl_tree;


typedef struct avl_walk_s
{
	avl_node	*node_stack[AVL_TREE_MAX_DEPTH],
			*node,
			*prev_node;
	int		stack_depth;
	void		*key,
			*data;
} avl_walk;


avl_tree *avlCreate(int);
int avlInsert(avl_tree*, void*, void*);
void *avlLookup(avl_tree*, void*);
void avlDelete(avl_tree*, void*);
void avlDestroy(avl_tree*);

int avlGetFirst(avl_tree*, avl_walk*);
int avlGetLast(avl_tree*, avl_walk*);
int avlGetNext(avl_tree*, avl_walk*);
