// C program to avlInsert a node in AVL tree
#include<stdio.h>
#include<stdlib.h>
#include<string.h>
#include "avl.h"


void printIntTree(node)
        avl_node *node;
{
	int	key;

        if (node == NULL)
                return;
        printIntTree(node->left);
	key = *(int*)node->key;
        printf("%d\n", key);
        printIntTree(node->right);
}


void printStringTree(node)
        avl_node *node;
{
        if (node == NULL)
                return;
        printStringTree(node->left);
        printf("%s => %s\n", (char *)node->key, (char*)node->data);
        printStringTree(node->right);
}


int main()
{
	avl_tree	*tree1 = NULL,
			*tree2 = NULL;
	avl_walk	cur;
	int		key;
	char		*cp;
/*
	tree1 = avlCreate(AVL_KEY_INT);

	key = 10; avlInsert(tree1, &key, NULL);
	key = 87; avlInsert(tree1, &key, NULL);
	key = 64; avlInsert(tree1, &key, NULL);
	key = 72; avlInsert(tree1, &key, NULL);
	key = 33; avlInsert(tree1, &key, NULL);
	key = 18; avlInsert(tree1, &key, NULL);
	key = 99; avlInsert(tree1, &key, NULL);
	key = 64; avlInsert(tree1, &key, NULL);
	key = 51; avlInsert(tree1, &key, NULL);
	key = 57; avlInsert(tree1, &key, NULL);
	key = 49; avlInsert(tree1, &key, NULL);
	key = 52; avlInsert(tree1, &key, NULL);
	key = 50; avlInsert(tree1, &key, NULL);
	key = 48; avlInsert(tree1, &key, NULL);
	key = 47; avlInsert(tree1, &key, NULL);
	key = 46; avlInsert(tree1, &key, NULL);
	key = 55; avlInsert(tree1, &key, NULL);
	key = 53; avlInsert(tree1, &key, NULL);
	key = 56; avlInsert(tree1, &key, NULL);
	key = 54; avlInsert(tree1, &key, NULL);
	key = -10; avlInsert(tree1, &key, NULL);

	printf("Traveral of tree gives :\n");
	printIntTree(tree1->root);
	printf("\n");
*/

	tree2 = avlCreate(AVL_KEY_STRING);
	cp = strdup("fred");
	avlInsert(tree2, "smith", cp);
	cp = strdup("gareth");
	avlInsert(tree2, "jones", cp);
	cp = strdup("david");
	avlInsert(tree2, "hughes", cp);
	cp = strdup("sharon");
	avlInsert(tree2, "garvey", cp);
	cp = strdup("ant");
	avlInsert(tree2, "aardvark", cp);
	cp = strdup("chucka");
	avlInsert(tree2, "zooloo", cp);
	cp = strdup("paul1");
	avlInsert(tree2, "peters", cp);
	cp = strdup("paul2");
	avlInsert(tree2, "collins", cp);
	cp = strdup("backa");
	avlInsert(tree2, "bourke", cp);
	cp = strdup("ranga");
	avlInsert(tree2, "gillard", cp);
	cp = strdup("john");
	avlInsert(tree2, "howard", cp);
	cp = strdup("norm");
	avlInsert(tree2, "yorston", cp);
	cp = strdup("dean");
	avlInsert(tree2, "cornish", cp);
	cp = strdup("scott");
	avlInsert(tree2, "harman", cp);
	cp = strdup("andy");
	avlInsert(tree2, "csabi", cp);
	cp = strdup("col");
	avlInsert(tree2, "davis", cp);
	cp = strdup("john");
	avlInsert(tree2, "edwards", cp);
	cp = strdup("brent");
	avlInsert(tree2, "paddon", cp);
	cp = strdup("jon");
	avlInsert(tree2, "eaves", cp);
	cp = strdup("terry");
	avlInsert(tree2, "manderson", cp);
	cp = strdup("random");
	avlInsert(tree2, "u12345678901234567890", cp);

	printf("\nTraveral of tree gives :\n");
	printStringTree(tree2->root);
	printf("\n");

	printf("\nDelete 'howard'\n");
	avlDelete(tree2,"howard");
	printf("\nTraveral of tree gives :\n");
	printStringTree(tree2->root);
	printf("\n");

	printf("\nInsert 'gates'\n");
	cp = strdup("bill");
	avlInsert(tree2, "gates", cp);
	printf("\nTraveral of tree gives :\n");
	printStringTree(tree2->root);
	printf("\n");


	printf("\n\nWalking tree\n\n");
	avlGetFirst(tree2, &cur);
	while(1)
	{
		printf("%s => %s\n", (char*)cur.key, (char*)cur.data);
		if (avlGetNext(tree2, &cur) == 0)
			break;
	}

	cp = avlLookup(tree2, "hughes");
	printf("%s hughes\n", cp);

	avlDestroy(tree1);
	avlDestroy(tree2);
}

